Index: issm/trunk/src/c/classes/Elements/TetraRef.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/TetraRef.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/TetraRef.cpp	(revision 18301)
@@ -4,5 +4,5 @@
 
 /*Headers:*/
-/*{{{*//*{{{*/
+/*{{{*/
 #ifdef HAVE_CONFIG_H
 #include <config.h>
@@ -23,38 +23,19 @@
 /*Object constructors and destructor*/
 TetraRef::TetraRef(){/*{{{*/
-	this->element_type_list=NULL;
-}
-/*}}}*/
-TetraRef::TetraRef(const int nummodels){/*{{{*/
-
-	/*Only allocate pointer*/
-	element_type_list=xNew<int>(nummodels);
-
 }
 /*}}}*/
 TetraRef::~TetraRef(){/*{{{*/
-	xDelete<int>(element_type_list);
-}
-/*}}}*/
-
-/*Management*/
-void TetraRef::SetElementType(int type,int type_counter){/*{{{*/
-
-	/*initialize element type*/
-	this->element_type_list[type_counter]=type;
 }
 /*}}}*/
 
 /*Reference Element numerics*/
-void TetraRef::GetNodalFunctions(IssmDouble* basis,GaussTetra* gauss){/*{{{*/
+void TetraRef::GetNodalFunctions(IssmDouble* basis,Gauss* gauss_in,int finiteelement){/*{{{*/
 	/*This routine returns the values of the nodal functions  at the gaussian point.*/
+
 	_assert_(basis);
-	GetNodalFunctions(basis,gauss,this->element_type);
-}
-/*}}}*/
-void TetraRef::GetNodalFunctions(IssmDouble* basis,GaussTetra* gauss,int finiteelement){/*{{{*/
-	/*This routine returns the values of the nodal functions  at the gaussian point.*/
-
-	_assert_(basis);
+
+	/*Cast gauss to GaussTetra*/
+	_assert_(gauss_in->Enum()==GaussTetraEnum);
+	GaussTetra* gauss = dynamic_cast<GaussTetra*>(gauss_in);
 
 	switch(finiteelement){
@@ -96,8 +77,4 @@
 }
 /*}}}*/
-void TetraRef::GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list, GaussTetra* gauss){/*{{{*/
-	GetNodalFunctionsDerivatives(dbasis,xyz_list,gauss,this->element_type);
-}
-/*}}}*/
 void TetraRef::GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list, GaussTetra* gauss,int finiteelement){/*{{{*/
 
@@ -133,12 +110,4 @@
 }
 /*}}}*/
-void TetraRef::GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,GaussTetra* gauss){/*{{{*/
-	/*This routine returns the values of the nodal functions derivatives  (with respect to the 
-	 * natural coordinate system) at the gaussian point. */
-
-	GetNodalFunctionsDerivativesReference(dbasis,gauss,this->element_type);
-
-}
-/*}}}*/
 void TetraRef::GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,GaussTetra* gauss,int finiteelement){/*{{{*/
 	/*This routine returns the values of the nodal functions derivatives  (with respect to the 
@@ -239,5 +208,5 @@
 }
 /*}}}*/
-void TetraRef::GetInputDerivativeValue(IssmDouble* p, IssmDouble* plist,IssmDouble* xyz_list, GaussTetra* gauss){/*{{{*/
+void TetraRef::GetInputDerivativeValue(IssmDouble* p, IssmDouble* plist,IssmDouble* xyz_list, GaussTetra* gauss,int finiteelement){/*{{{*/
 	/*From node values of parameter p (p_list[0], p_list[1], p_list[2],
 	 * p_list[3], p_list[4] and p_list[4]), return parameter derivative value at
@@ -256,9 +225,9 @@
 
 	/*Fetch number of nodes for this finite element*/
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(finiteelement);
 
 	/*Get nodal functions derivatives*/
 	IssmDouble* dbasis=xNew<IssmDouble>(3*numnodes);
-	GetNodalFunctionsDerivatives(dbasis,xyz_list,gauss);
+	GetNodalFunctionsDerivatives(dbasis,xyz_list,gauss,finiteelement);
 
 	/*Calculate parameter for this Gauss point*/
@@ -274,10 +243,5 @@
 }
 /*}}}*/
-void TetraRef::GetInputValue(IssmDouble* p, IssmDouble* plist, GaussTetra* gauss){/*{{{*/
-
-	GetInputValue(p,plist,gauss,this->element_type);
-}
-/*}}}*/
-void TetraRef::GetInputValue(IssmDouble* p, IssmDouble* plist, GaussTetra* gauss,int finiteelement){/*{{{*/
+void TetraRef::GetInputValue(IssmDouble* p, IssmDouble* plist, Gauss* gauss,int finiteelement){/*{{{*/
 
 	/*Output*/
@@ -374,9 +338,4 @@
 	/*Invert Jacobian matrix: */
 	Matrix3x3Invert(Jinv,&J[0][0]);
-}
-/*}}}*/
-int  TetraRef::NumberofNodes(void){/*{{{*/
-
-	return this->NumberofNodes(this->element_type);
 }
 /*}}}*/
@@ -395,5 +354,7 @@
 		case MINIEnum:              return NUMNODESP1b+NUMNODESP1;
 		case TaylorHoodEnum:        return NUMNODESP2+NUMNODESP1;
-		default: _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+		case LATaylorHoodEnum:      return NUMNODESP2;
+		case XTaylorHoodEnum:       return NUMNODESP2+NUMNODESP1;
+		default: _error_("Element type "<<EnumToStringx(finiteelement)<<" not supported yet");
 	}
 
@@ -401,7 +362,7 @@
 }
 /*}}}*/
-int  TetraRef::VelocityInterpolation(void){/*{{{*/
-
-	switch(this->element_type){
+int  TetraRef::VelocityInterpolation(int fe_stokes){/*{{{*/
+
+	switch(fe_stokes){
 		case P1P1Enum:          return P1Enum;
 		case P1P1GLSEnum:       return P1Enum;
@@ -409,5 +370,7 @@
 		case MINIEnum:          return P1bubbleEnum;
 		case TaylorHoodEnum:    return P2Enum;
-		default:       _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+		case LATaylorHoodEnum:  return P2Enum;
+		case XTaylorHoodEnum:   return P2Enum;
+		default:       _error_("Element type "<<EnumToStringx(fe_stokes)<<" not supported yet");
 	}
 
@@ -415,7 +378,7 @@
 }
 /*}}}*/
-int TetraRef::PressureInterpolation(void){/*{{{*/
-
-	switch(this->element_type){
+int  TetraRef::PressureInterpolation(int fe_stokes){/*{{{*/
+
+	switch(fe_stokes){
 		case P1P1Enum:          return P1Enum;
 		case P1P1GLSEnum:       return P1Enum;
@@ -423,16 +386,18 @@
 		case MINIEnum:          return P1Enum;
 		case TaylorHoodEnum:    return P1Enum;
-		default:       _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
+		case LATaylorHoodEnum:  return NoneEnum;
+		case XTaylorHoodEnum:   return P1Enum;
+		default:       _error_("Element type "<<EnumToStringx(fe_stokes)<<" not supported yet");
 	}
 
 	return -1;
 }/*}}}*/
-int  TetraRef::TensorInterpolation(void){/*{{{*/
+int  TetraRef::TensorInterpolation(int fe_stokes){/*{{{*/
 	/*This routine returns the values of the nodal functions  at the gaussian point.*/
 
-	switch(this->element_type){
+	switch(fe_stokes){
 		case XTaylorHoodEnum: return P1DGEnum;
-		default: _error_("Element type "<<EnumToStringx(this->element_type)<<" not supported yet");
-	}
-}
-/*}}}*/
+		default: _error_("Element type "<<EnumToStringx(fe_stokes)<<" not supported yet");
+	}
+}
+/*}}}*/
Index: issm/trunk/src/c/classes/Elements/TetraRef.h
===================================================================
--- issm/trunk/src/c/classes/Elements/TetraRef.h	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/TetraRef.h	(revision 18301)
@@ -13,32 +13,21 @@
 
 	public: 
-		int* element_type_list;
-		int  element_type;
-
 		TetraRef();
-		TetraRef(const int nummodels);
 		~TetraRef();
 
-		/*Management*/
-		void SetElementType(int type,int type_counter);
 		void GetJacobian(IssmDouble* J, IssmDouble* xyz_list,GaussTetra* gauss);
 		void GetJacobianDeterminant(IssmDouble*  Jdet, IssmDouble* xyz_list,GaussTetra* gauss);
 		void GetJacobianDeterminantFace(IssmDouble*  Jdet, IssmDouble* xyz_list,GaussTetra* gauss);
 		void GetJacobianInvert(IssmDouble* Jinv, IssmDouble* xyz_list,GaussTetra* gauss);
-		void GetNodalFunctions(IssmDouble* basis,GaussTetra* gauss);
-		void GetNodalFunctions(IssmDouble* basis,GaussTetra* gauss,int finiteelement);
-		void GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list, GaussTetra* gauss);
+		void GetNodalFunctions(IssmDouble* basis,Gauss* gauss_in,int finiteelement);
 		void GetNodalFunctionsDerivatives(IssmDouble* dbasis,IssmDouble* xyz_list, GaussTetra* gauss,int finiteelement);
-		void GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,GaussTetra* gauss);
 		void GetNodalFunctionsDerivativesReference(IssmDouble* dbasis,GaussTetra* gauss,int finiteelement);
-		void GetInputDerivativeValue(IssmDouble* p, IssmDouble* plist,IssmDouble* xyz_list, GaussTetra* gauss);
-		void GetInputValue(IssmDouble* p, IssmDouble* plist, GaussTetra* gauss);
-		void GetInputValue(IssmDouble* p, IssmDouble* plist, GaussTetra* gauss,int finiteelement);
+		void GetInputDerivativeValue(IssmDouble* p, IssmDouble* plist,IssmDouble* xyz_list, GaussTetra* gauss,int finiteelement);
+		void GetInputValue(IssmDouble* p, IssmDouble* plist, Gauss* gauss,int finiteelement);
 
-		int  NumberofNodes(void);
 		int  NumberofNodes(int finiteelement);
-		int  VelocityInterpolation(void);
-		int  PressureInterpolation(void);
-		int  TensorInterpolation(void);
+		int  VelocityInterpolation(int fe_stokes);
+		int  PressureInterpolation(int fe_stokes);
+		int  TensorInterpolation(int fe_stokes);
 };
 #endif
Index: issm/trunk/src/c/classes/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 18301)
@@ -25,5 +25,5 @@
 /*Constructors/destructor/copy*/
 Tria::Tria(int tria_id, int tria_sid, int index, IoModel* iomodel,int nummodels)/*{{{*/
-	:TriaRef(nummodels),ElementHook(nummodels,index+1,NUMVERTICES,iomodel){
+	:ElementHook(nummodels,index+1,NUMVERTICES,iomodel){
 
 		/*id: */
@@ -42,4 +42,10 @@
 		this->material = NULL;
 		this->matpar   = NULL;
+		if(nummodels>0){
+			this->element_type_list=xNew<int>(nummodels);
+			for(int i=0;i<nummodels;i++) this->element_type_list[i] = 0;
+		}
+		else this->element_type_list = NULL;
+
 }
 /*}}}*/
@@ -56,34 +62,52 @@
 
 	//deal with TriaRef mother class
-	tria->element_type_list=xNew<int>(this->numanalyses);
-	for(i=0;i<this->numanalyses;i++) tria->element_type_list[i]=this->element_type_list[i];
+	int nanalyses = this->numanalyses;
+	if(nanalyses > 0){
+		tria->element_type_list=xNew<int>(nanalyses);
+		for(i=0;i<nanalyses;i++){
+			if (this->element_type_list[i]) tria->element_type_list[i]=this->element_type_list[i];
+			else tria->element_type_list[i] = 0;
+		}
+	}
+	else tria->element_type_list = NULL;
+	tria->element_type=this->element_type;
+	tria->numanalyses=nanalyses;
 
 	//deal with ElementHook mother class
-	tria->numanalyses=this->numanalyses;
-	tria->hnodes=new Hook*[tria->numanalyses];
-	for(i=0;i<tria->numanalyses;i++)tria->hnodes[i]=(Hook*)this->hnodes[i]->copy();
+	if (this->hnodes){
+		tria->hnodes=xNew<Hook*>(tria->numanalyses);
+		for(i=0;i<tria->numanalyses;i++){
+			if (this->hnodes[i]) tria->hnodes[i] = (Hook*)(this->hnodes[i]->copy());
+			else tria->hnodes[i] = NULL;
+		}
+	}
+	else tria->hnodes = NULL;
+
 	tria->hvertices = (Hook*)this->hvertices->copy();
 	tria->hmaterial = (Hook*)this->hmaterial->copy();
 	tria->hmatpar   = (Hook*)this->hmatpar->copy();
+	tria->hneighbors = NULL;
 
 	/*deal with Tria fields: */
 	tria->id  = this->id;
 	tria->sid = this->sid;
-	if(this->inputs){
-		tria->inputs=(Inputs*)this->inputs->Copy();
-	}
-	else{
-		tria->inputs=new Inputs();
-	}
+	if(this->inputs) tria->inputs = (Inputs*)(this->inputs->Copy());
+	else tria->inputs=new Inputs();
+
 	/*point parameters: */
 	tria->parameters=this->parameters;
 
 	/*recover objects: */
-	tria->nodes = xNew<Node*>(3); //we cannot rely on an analysis_counter to tell us which analysis_type we are running, so we just copy the nodes.
-	for(i=0;i<3;i++)tria->nodes[i]=this->nodes[i];
-
-	tria->vertices = (Vertex**)tria->hvertices->deliverp();
-	tria->material = (Material*)tria->hmaterial->delivers();
-	tria->matpar   = (Matpar*)tria->hmatpar->delivers();
+	if (this->nodes){
+		unsigned int num_nodes = 3;
+		tria->nodes = xNew<Node*>(num_nodes); //we cannot rely on an analysis_counter to tell us which analysis_type we are running, so we just copy the nodes.
+		for(i=0;i<num_nodes;i++) if(this->nodes[i]) tria->nodes[i]=this->nodes[i]; else tria->nodes[i] = NULL;
+	}
+	else tria->nodes = NULL;
+	
+
+	tria->vertices = (Vertex**)this->hvertices->deliverp();
+	tria->material = (Material*)this->hmaterial->delivers();
+	tria->matpar   = (Matpar*)this->hmatpar->delivers();
 
 	return tria;
@@ -197,49 +221,4 @@
 }
 /*}}}*/
-void       Tria::ComputeStrainRate(){/*{{{*/
-
-	IssmDouble      xyz_list[NUMVERTICES][3];
-	IssmDouble      epsilon[6]; /* epsilon=[exx,eyy,exy];*/
-	IssmDouble      eps_xx[NUMVERTICES];
-	IssmDouble		 eps_yy[NUMVERTICES];
-	IssmDouble		 eps_zz[NUMVERTICES]={0,0,0};
-	IssmDouble      eps_xy[NUMVERTICES];
-	IssmDouble		 eps_xz[NUMVERTICES]={0,0,0};
-	IssmDouble		 eps_yz[NUMVERTICES]={0,0,0};
-	GaussTria*     gauss=NULL;
-
-	/* Get node coordinates and dof list: */
-	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-
-	/*Retrieve all inputs we will be needing: */
-	Input* vx_input=inputs->GetInput(VxEnum);             _assert_(vx_input);
-	Input* vy_input=inputs->GetInput(VyEnum);             _assert_(vy_input);
-
-	/* Start looping on the number of vertices: */
-	gauss=new GaussTria();
-	for (int iv=0;iv<NUMVERTICES;iv++){
-		gauss->GaussVertex(iv);
-
-		/*Compute strain rate viscosity and pressure: */
-		this->StrainRateSSA(&epsilon[0],&xyz_list[0][0],gauss,vx_input,vy_input);
-
-		eps_xx[iv]=epsilon[0]; 
-		eps_yy[iv]=epsilon[1];
-		eps_xy[iv]=epsilon[2];
-	}
-
-	/*Add Stress tensor components into inputs*/
-	this->inputs->AddInput(new TriaInput(StrainRatexxEnum,&eps_xx[0],P1Enum));
-	this->inputs->AddInput(new TriaInput(StrainRatexyEnum,&eps_xy[0],P1Enum));
-	this->inputs->AddInput(new TriaInput(StrainRatexzEnum,&eps_xz[0],P1Enum));
-	this->inputs->AddInput(new TriaInput(StrainRateyyEnum,&eps_yy[0],P1Enum));
-	this->inputs->AddInput(new TriaInput(StrainRateyzEnum,&eps_yz[0],P1Enum));
-	this->inputs->AddInput(new TriaInput(StrainRatezzEnum,&eps_zz[0],P1Enum));
-
-	/*Clean up and return*/
-	delete gauss;
-
-}
-/*}}}*/
 void       Tria::ComputeStressTensor(){/*{{{*/
 
@@ -351,9 +330,13 @@
 
 	/*Get Element type*/
-	this->element_type=this->element_type_list[analysis_counter];
+	if (this->element_type_list) this->element_type=this->element_type_list[analysis_counter];
 
 	/*Take care of hooking up all objects for this element, ie links the objects in the hooks to their respective 
 	 * datasets, using internal ids and offsets hidden in hooks: */
-	if(this->hnodes[analysis_counter]) this->hnodes[analysis_counter]->configure(nodesin);
+	if(this->hnodes){
+		if (this->hnodes[analysis_counter]) this->hnodes[analysis_counter]->configure(nodesin);
+		else this->hnodes[analysis_counter] = NULL;
+	}
+	else this->hnodes = NULL; 
 	this->hvertices->configure(verticesin);
 	this->hmaterial->configure(materialsin);
@@ -361,5 +344,5 @@
 
 	/*Now, go pick up the objects inside the hooks: */
-	if(this->hnodes[analysis_counter]) this->nodes=(Node**)this->hnodes[analysis_counter]->deliverp();
+	if(this->hnodes && this->hnodes[analysis_counter]) this->nodes=(Node**)this->hnodes[analysis_counter]->deliverp();
 	else this->nodes=NULL;
 	this->vertices = (Vertex**)this->hvertices->deliverp();
@@ -371,5 +354,5 @@
 
 	/*get inputs configured too: */
-	this->inputs->Configure(parameters);
+	this->inputs->Configure(this->parameters);
 
 }
@@ -889,4 +872,44 @@
 	xDelete<int>(indicesfront);
 }/*}}}*/
+void       Tria::GetLevelCoordinates(IssmDouble** pxyz_front,IssmDouble* xyz_list,int levelsetenum,IssmDouble level){/*{{{*/
+
+	/* Intermediaries */
+	int i, dir,nrfrontnodes;
+	IssmDouble  levelset[NUMVERTICES];
+
+	/*Recover parameters and values*/
+	GetInputListOnVertices(&levelset[0],levelsetenum);
+
+	int* indicesfront = xNew<int>(NUMVERTICES);
+	/* Get nodes where there is no ice */
+	nrfrontnodes=0;
+	for(i=0;i<NUMVERTICES;i++){
+		if(levelset[i]==level){
+			indicesfront[nrfrontnodes]=i;
+			nrfrontnodes++;
+		}
+	}
+
+	_assert_(nrfrontnodes==2);
+
+	/* arrange order of frontnodes such that they are oriented counterclockwise */
+	if((NUMVERTICES+indicesfront[0]-indicesfront[1])%NUMVERTICES!=NUMVERTICES-1){
+		int index=indicesfront[0];
+		indicesfront[0]=indicesfront[1];
+		indicesfront[1]=index;
+	}	
+
+	IssmDouble* xyz_front = xNew<IssmDouble>(3*nrfrontnodes);
+	/* Return nodes */
+	for(i=0;i<nrfrontnodes;i++){
+		for(dir=0;dir<3;dir++){
+			xyz_front[3*i+dir]=xyz_list[3*indicesfront[i]+dir];
+		}
+	}
+
+	*pxyz_front=xyz_front;
+
+	xDelete<int>(indicesfront);
+}/*}}}*/
 int        Tria::GetNodeIndex(Node* node){/*{{{*/
 
@@ -900,5 +923,10 @@
 /*}}}*/
 int        Tria::GetNumberOfNodes(void){/*{{{*/
-	return this->NumberofNodes();
+	if (this->nodes) return this->NumberofNodes(this->element_type);
+	else return 0;
+}
+/*}}}*/
+int        Tria::GetNumberOfNodes(int enum_type){/*{{{*/
+	return this->NumberofNodes(enum_type);
 }
 /*}}}*/
@@ -921,5 +949,5 @@
 Node*      Tria::GetNode(int node_number){/*{{{*/
 	_assert_(node_number>=0); 
-	_assert_(node_number<this->NumberofNodes()); 
+	_assert_(node_number<this->NumberofNodes(this->element_type)); 
 	return this->nodes[node_number];
 
@@ -983,5 +1011,4 @@
 	}
 
-
 	/*Control Inputs*/
 	if (control_analysis && iomodel->Data(InversionControlParametersEnum)){
@@ -991,4 +1018,5 @@
 				/*yts conversion*/
 				case BalancethicknessThickeningRateEnum:
+				case BalancethicknessApparentMassbalanceEnum:
 				case VxEnum:
 				case VyEnum:
@@ -1058,5 +1086,5 @@
 
 	/*Fetch number of nodes for this finite element*/
-	int numnodes = this->NumberofNodes();
+	int numnodes = this->NumberofNodes(this->element_type);
 
 	/*Fetch dof list and allocate solution vector*/
@@ -1109,5 +1137,5 @@
 
 		/*Get number of nodes and dof list: */
-		numnodes = this->NumberofNodes();
+		numnodes = this->NumberofNodes(this->element_type);
 		values   = xNew<IssmDouble>(numnodes);
 		GetDofList(&doflist,NoneApproximationEnum,GsetEnum);
@@ -1123,5 +1151,5 @@
 
 		/*Get number of nodes and dof list: */
-		numnodes = this->NumberofNodes();
+		numnodes = this->NumberofNodes(this->element_type);
 		values   = xNew<IssmDouble>(numnodes);
 
@@ -1452,5 +1480,19 @@
 
 	_assert_(gauss->Enum()==GaussTriaEnum);
-	this->GetNodalFunctions(basis,(GaussTria*)gauss);
+	this->GetNodalFunctions(basis,(GaussTria*)gauss,this->element_type);
+
+}
+/*}}}*/
+void       Tria::NodalFunctionsP1(IssmDouble* basis, Gauss* gauss){/*{{{*/
+
+	_assert_(gauss->Enum()==GaussTriaEnum);
+	this->GetNodalFunctions(basis,(GaussTria*)gauss,P1Enum);
+
+}
+/*}}}*/
+void       Tria::NodalFunctionsP2(IssmDouble* basis, Gauss* gauss){/*{{{*/
+
+	_assert_(gauss->Enum()==GaussTriaEnum);
+	this->GetNodalFunctions(basis,(GaussTria*)gauss,P2Enum);
 
 }
@@ -1459,5 +1501,12 @@
 
 	_assert_(gauss->Enum()==GaussTriaEnum);
-	this->GetNodalFunctionsDerivatives(dbasis,xyz_list,(GaussTria*)gauss);
+	this->GetNodalFunctionsDerivatives(dbasis,xyz_list,(GaussTria*)gauss,this->element_type);
+
+}
+/*}}}*/
+void       Tria::NodalFunctionsP1Derivatives(IssmDouble* dbasis,IssmDouble* xyz_list,Gauss* gauss){/*{{{*/
+
+	_assert_(gauss->Enum()==GaussTriaEnum);
+	this->GetNodalFunctionsDerivatives(dbasis,xyz_list,(GaussTria*)gauss,P1Enum);
 
 }
@@ -1558,13 +1607,13 @@
 /*}}}*/
 int        Tria::VelocityInterpolation(void){/*{{{*/
-	return TriaRef::VelocityInterpolation();
+	return TriaRef::VelocityInterpolation(this->element_type);
 }
 /*}}}*/
 int        Tria::PressureInterpolation(void){/*{{{*/
-	return TriaRef::PressureInterpolation();
+	return TriaRef::PressureInterpolation(this->element_type);
 }
 /*}}}*/
 int        Tria::TensorInterpolation(void){/*{{{*/
-	return TriaRef::TensorInterpolation();
+	return TriaRef::TensorInterpolation(this->element_type);
 }
 /*}}}*/
@@ -1714,52 +1763,24 @@
 }
 /*}}}*/
+void       Tria::ResetHooks(){/*{{{*/
+
+	this->nodes=NULL;
+	this->vertices=NULL;
+	this->material=NULL;
+	this->matpar=NULL;
+	this->parameters=NULL;
+
+	//deal with ElementHook mother class
+	for(int i=0;i<this->numanalyses;i++) if(this->hnodes[i]) this->hnodes[i]->reset();
+	this->hvertices->reset();
+	this->hmaterial->reset();
+	this->hmatpar->reset();
+	if(this->hneighbors) this->hneighbors->reset();
+
+}
+/*}}}*/
 void       Tria::SetClone(int* minranks){/*{{{*/
 
 	_error_("not implemented yet");
-}
-/*}}}*/
-void       Tria::SmbGradients(void){/*{{{*/
-
-	int i;
-
-	// input
-   IssmDouble h[NUMVERTICES];					// ice thickness (m)		
-	IssmDouble s[NUMVERTICES];					// surface elevation (m)
-	IssmDouble b_pos[NUMVERTICES];				// Hs-SMB relation parameter
-	IssmDouble b_neg[NUMVERTICES];				// Hs-SMB relation paremeter
-	IssmDouble Href[NUMVERTICES];					// reference elevation from which deviations are used to calculate the SMB adjustment
-	IssmDouble Smbref[NUMVERTICES];				// reference SMB to which deviations are added
-   IssmDouble rho_water;                   // density of fresh water
-	IssmDouble rho_ice;                     // density of ice
-
-	// output
-	IssmDouble smb[NUMVERTICES];					// surface mass balance (m/yr ice)
-
-	/*Recover SmbGradients*/
-	GetInputListOnVertices(&Href[0],SurfaceforcingsHrefEnum);
-	GetInputListOnVertices(&Smbref[0],SurfaceforcingsSmbrefEnum);
-	GetInputListOnVertices(&b_pos[0],SurfaceforcingsBPosEnum);
-	GetInputListOnVertices(&b_neg[0],SurfaceforcingsBNegEnum);
-
-   /*Recover surface elevatio at vertices: */
-	GetInputListOnVertices(&h[0],ThicknessEnum);
-	GetInputListOnVertices(&s[0],SurfaceEnum);
-
-   /*Get material parameters :*/
-   rho_ice=matpar->GetRhoIce();
-   rho_water=matpar->GetRhoFreshwater();
-
-   // loop over all vertices
-   for(i=0;i<NUMVERTICES;i++){
-     if(Smbref[i]>0){
-		  smb[i]=Smbref[i]+b_pos[i]*(s[i]-Href[i]);
-	  }
-	  else{
-		  smb[i]=Smbref[i]+b_neg[i]*(s[i]-Href[i]);
-	  }
-	  smb[i]=smb[i]/rho_ice;      // SMB in m/y ice		
-		}  //end of the loop over the vertices
-	  /*Update inputs*/
-	  this->inputs->AddInput(new TriaInput(SurfaceforcingsMassBalanceEnum,&smb[0],P1Enum));
 }
 /*}}}*/
@@ -1834,9 +1855,10 @@
 
 	/*Get Element type*/
-	this->element_type=this->element_type_list[analysis_counter];
+	if(this->element_type_list) this->element_type=this->element_type_list[analysis_counter];
 
 	/*Pick up nodes*/
-	if(this->hnodes[analysis_counter]) this->nodes=(Node**)this->hnodes[analysis_counter]->deliverp();
-	else this->nodes=NULL;
+	if(this->hnodes && this->hnodes[analysis_counter]){
+		this->nodes=(Node**)this->hnodes[analysis_counter]->deliverp();
+	}
 
 }
@@ -1884,6 +1906,6 @@
 
 	/*Get for Vx and Vy, the max of abs value: */
-	this->MaxAbsVx(&maxabsvx);
-	this->MaxAbsVy(&maxabsvy);
+	maxabsvx = this->inputs->MaxAbs(VxEnum);
+	maxabsvy = this->inputs->MaxAbs(VyEnum);
 
 	/* Get node coordinates and dof list: */
@@ -1920,5 +1942,5 @@
 
 	/*Recover element type*/
-	this->SetElementType(finiteelement_type,analysis_counter);
+	this->element_type_list[analysis_counter]=finiteelement_type;
 
 	/*Recover nodes ids needed to initialize the node hook.*/
@@ -1956,4 +1978,15 @@
 			tria_node_ids[5]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[3*index+2]+1;
 			break;
+		case P2bubbleEnum: case P2bubblecondensedEnum:
+			numnodes        = 7;
+			tria_node_ids   = xNew<int>(numnodes);
+			tria_node_ids[0]=iomodel->nodecounter+iomodel->elements[3*index+0];
+			tria_node_ids[1]=iomodel->nodecounter+iomodel->elements[3*index+1];
+			tria_node_ids[2]=iomodel->nodecounter+iomodel->elements[3*index+2];
+			tria_node_ids[3]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[3*index+0]+1;
+			tria_node_ids[4]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[3*index+1]+1;
+			tria_node_ids[5]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[3*index+2]+1;
+			tria_node_ids[6]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+index+1;
+			break;
 		case P1P1Enum: case P1P1GLSEnum:
 			numnodes        = 6;
@@ -1994,4 +2027,29 @@
 			tria_node_ids[8]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->elements[3*index+2];
 			break;
+		case LATaylorHoodEnum:
+			numnodes        = 6;
+			tria_node_ids   = xNew<int>(numnodes);
+			tria_node_ids[0]=iomodel->nodecounter+iomodel->elements[3*index+0];
+			tria_node_ids[1]=iomodel->nodecounter+iomodel->elements[3*index+1];
+			tria_node_ids[2]=iomodel->nodecounter+iomodel->elements[3*index+2];
+			tria_node_ids[3]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[3*index+0]+1;
+			tria_node_ids[4]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[3*index+1]+1;
+			tria_node_ids[5]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[3*index+2]+1;
+			break;
+		case CrouzeixRaviartEnum:
+			numnodes        = 10;
+			tria_node_ids   = xNew<int>(numnodes);
+			tria_node_ids[0]=iomodel->nodecounter+iomodel->elements[3*index+0];
+			tria_node_ids[1]=iomodel->nodecounter+iomodel->elements[3*index+1];
+			tria_node_ids[2]=iomodel->nodecounter+iomodel->elements[3*index+2];
+			tria_node_ids[3]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[3*index+0]+1;
+			tria_node_ids[4]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[3*index+1]+1;
+			tria_node_ids[5]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->elementtoedgeconnectivity[3*index+2]+1;
+			tria_node_ids[6]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+index+1;
+
+			tria_node_ids[7]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberofelements+3*index+1;
+			tria_node_ids[8]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberofelements+3*index+2;
+			tria_node_ids[9]=iomodel->nodecounter+iomodel->numberofvertices+iomodel->numberofedges+iomodel->numberofelements+3*index+3;
+			break;
 		default:
 			_error_("Finite element "<<EnumToStringx(finiteelement_type)<<" not supported yet");
@@ -2018,5 +2076,5 @@
 
 	GaussTria* gauss=new GaussTria();
-	for(int iv=0;iv<this->NumberofNodes();iv++){
+	for(int iv=0;iv<this->NumberofNodes(this->element_type);iv++){
 		gauss->GaussNode(this->element_type,iv);
 		onbase->GetInputValue(&isonbase,gauss);
@@ -2057,5 +2115,5 @@
 /*}}}*/
 void       Tria::ValueP1DerivativesOnGauss(IssmDouble* dvalue,IssmDouble* values,IssmDouble* xyz_list,Gauss* gauss){/*{{{*/
-	TriaRef::GetInputDerivativeValue(dvalue,values,xyz_list,gauss);
+	TriaRef::GetInputDerivativeValue(dvalue,values,xyz_list,gauss,P1Enum);
 }
 /*}}}*/
@@ -2346,104 +2404,4 @@
 	delete gauss_2;
 	return mass_flux;
-}
-/*}}}*/
-void       Tria::MaxAbsVx(IssmDouble* pmaxabsvx){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxabsvx=this->inputs->MaxAbs(VxEnum);
-
-	/*Assign output pointers:*/
-	*pmaxabsvx=maxabsvx;
-}
-/*}}}*/
-void       Tria::MaxAbsVy(IssmDouble* pmaxabsvy){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxabsvy=this->inputs->MaxAbs(VyEnum);
-
-	/*Assign output pointers:*/
-	*pmaxabsvy=maxabsvy;
-}
-/*}}}*/
-void       Tria::MaxAbsVz(IssmDouble* pmaxabsvz){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxabsvz=this->inputs->MaxAbs(VzEnum);
-
-	/*Assign output pointers:*/
-	*pmaxabsvz=maxabsvz;
-}
-/*}}}*/
-void       Tria::MaxVel(IssmDouble* pmaxvel){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxvel=this->inputs->Max(VelEnum);
-
-	/*Assign output pointers:*/
-	*pmaxvel=maxvel;
-}
-/*}}}*/
-void       Tria::MaxVx(IssmDouble* pmaxvx){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxvx=this->inputs->Max(VxEnum);
-
-	/*Assign output pointers:*/
-	*pmaxvx=maxvx;
-}
-/*}}}*/
-void       Tria::MaxVy(IssmDouble* pmaxvy){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxvy=this->inputs->Max(VyEnum);
-
-	/*Assign output pointers:*/
-	*pmaxvy=maxvy;
-
-}
-/*}}}*/
-void       Tria::MaxVz(IssmDouble* pmaxvz){/*{{{*/
-
-	/*Get maximum:*/
-	IssmDouble maxvz=this->inputs->Max(VzEnum);
-
-	/*Assign output pointers:*/
-	*pmaxvz=maxvz;
-}
-/*}}}*/
-void       Tria::MinVel(IssmDouble* pminvel){/*{{{*/
-
-	/*Get minimum:*/
-	IssmDouble minvel=this->inputs->Min(VelEnum);
-
-	/*Assign output pointers:*/
-	*pminvel=minvel;
-}
-/*}}}*/
-void       Tria::MinVx(IssmDouble* pminvx){/*{{{*/
-
-	/*Get minimum:*/
-	IssmDouble minvx=this->inputs->Min(VxEnum);
-
-	/*Assign output pointers:*/
-	*pminvx=minvx;
-}
-/*}}}*/
-void       Tria::MinVy(IssmDouble* pminvy){/*{{{*/
-
-	/*Get minimum:*/
-	IssmDouble minvy=this->inputs->Min(VyEnum);
-
-	/*Assign output pointers:*/
-	*pminvy=minvy;
-}
-/*}}}*/
-void       Tria::MinVz(IssmDouble* pminvz){/*{{{*/
-
-	/*Get minimum:*/
-	IssmDouble minvz=this->inputs->Min(VzEnum);
-
-	/*Assign output pointers:*/
-	*pminvz=minvz;
 }
 /*}}}*/
@@ -2735,24 +2693,4 @@
 }
 /*}}}*/
-void       Tria::ControlInputGetGradient(Vector<IssmDouble>* gradient,int enum_type,int control_index){/*{{{*/
-
-	int vertexpidlist[NUMVERTICES];
-
-	Input* input=inputs->GetInput(enum_type);
-	if (!input) _error_("Input " << EnumToStringx(enum_type) << " not found");
-	if (input->ObjectEnum()!=ControlInputEnum) _error_("Input " << EnumToStringx(enum_type) << " is not a ControlInput");
-
-	GradientIndexing(&vertexpidlist[0],control_index);
-	((ControlInput*)input)->GetGradient(gradient,&vertexpidlist[0]);
-
-}/*}}}*/
-void       Tria::ControlInputScaleGradient(int enum_type,IssmDouble scale){/*{{{*/
-
-	Input* input=inputs->GetInput(enum_type);
-	if (!input) _error_("Input " << EnumToStringx(enum_type) << " not found");
-	if (input->ObjectEnum()!=ControlInputEnum) _error_("Input " << EnumToStringx(enum_type) << " is not a ControlInput");
-
-	((ControlInput*)input)->ScaleGradient(scale);
-}/*}}}*/
 void       Tria::ControlInputSetGradient(IssmDouble* gradient,int enum_type,int control_index){/*{{{*/
 
